---
title: HTMLOutputElement
slug: Web/API/HTMLOutputElement
tags:
  - API
  - HTML DOM
  - Interface
  - Reference
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <strong><code>HTMLOutputElement</code></strong> interface provides properties and methods (beyond those inherited from {{domxref("HTMLElement")}}) for manipulating the layout and presentation of {{HTMLElement("output")}} elements.</p>

<p>{{InheritanceDiagram(600, 120)}}</p>

<h2 id="Properties">Properties</h2>

<p><em>This interface also inherits properties from its parent, {{domxref("HTMLElement")}}.</em></p>

<dl>
 <dt>{{domxref("HTMLOutputElement.defaultValue")}}</dt>
 <dd>A {{domxref("DOMString")}} representing the default value of the element, initially the empty string.</dd>
 <dt>{{domxref("HTMLOutputElement.form")}}{{ReadOnlyInline}}</dt>
 <dd>An {{domxref("HTMLFormElement")}} indicating the form associated with the control, reflecting the {{htmlattrxref("form", "output")}} HTML attribute if it is defined.</dd>
 <dt>{{domxref("HTMLOutputElement.htmlFor")}}{{ReadOnlyInline}}</dt>
 <dd>A {{domxref("DOMTokenList")}} reflecting the {{htmlattrxref("for", "output")}} HTML attribute, containing a list of IDs of other elements in the same document that contribute to (or otherwise affect) the calculated <code>value</code>.</dd>
 <dt>{{domxref("HTMLOutputElement.labels")}}{{ReadOnlyInline}}</dt>
 <dd>A {{domxref("NodeList")}} of {{HTMLElement("label")}} elements associated with the element.</dd>
 <dt>{{domxref("HTMLOutputElement.name")}}</dt>
 <dd>A {{domxref("DOMString")}} reflecting the {{htmlattrxref("name", "output")}} HTML attribute, containing the name for the control that is submitted with form data.</dd>
 <dt>{{domxref("HTMLOutputElement.type")}}{{ReadOnlyInline}}</dt>
 <dd>The {{domxref("DOMString")}} "<code>output</code>".</dd>
 <dt>{{domxref("HTMLOutputElement.validationMessage")}}{{ReadOnlyInline}}</dt>
 <dd>A {{domxref("DOMString")}} representing a localized message that describes the validation constraints that the control does not satisfy (if any). This is the empty string if the control is not a candidate for constraint validation (<code>willValidate</code> is <code>false</code>), or it satisfies its constraints.</dd>
 <dt>{{domxref("HTMLOutputElement.validity")}}{{ReadOnlyInline}}</dt>
 <dd>A {{domxref("ValidityState")}} representing the validity states that this element is in.</dd>
 <dt>{{domxref("HTMLOutputElement.value")}}</dt>
 <dd>A {{domxref("DOMString")}} representing the value of the contents of the elements. Behaves like the {{domxref("Node.textContent")}} property.</dd>
 <dt>{{domxref("HTMLOutputElement.willValidate")}}{{ReadOnlyInline}}</dt>
 <dd>A {{jsxref("Boolean")}} indicating whether the element is a candidate for constraint validation.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface also inherits methods from its parent, {{domxref("HTMLElement")}}.</em></p>

<dl>
 <dt>{{domxref("HTMLOutputElement.checkValidity()")}}</dt>
 <dd>Checks the validity of the element and returns a {{jsxref("Boolean")}} holding the check result.</dd>
 <dt>{{domxref("HTMLOutputElement.reportValidity()")}}</dt>
 <dd>This method reports the problems with the constraints on the element, if any, to the user. If there are problems, fires an {{domxref("HTMLInputElement/invalid_event", "invalid")}} event at the element, and returns <code>false</code>; if there are no problems, it returns <code>true</code>.</dd>
 <dd>When the problem is reported, the user agent may focus the element and change the scrolling position of the document or perform some other action that brings the element to the user's attention. User agents may report more than one constraint violation if this element suffers from multiple problems at once. If the element is not rendered, then the user agent may report the error for the running script instead of notifying the user.</dd>
 <dt>{{domxref("HTMLOutputElement.setCustomValidity()")}}</dt>
 <dd>Sets a custom validity message for the element. If this message is not the empty string, then the element is suffering from a custom validity error, and does not validate.</dd>
</dl>

<h2 id="Modes">Modes</h2>

<p>This element behaves in one of two modes: <em>default</em> mode and <em>value</em> mode.</p>

<h3 id="Default_mode">Default mode</h3>

<p>Initially, the element is in default mode, and so the contents of the element represent both the value of the element and its default value.</p>

<p>If the element is in default mode when the descendants of the element are changed in any way, the <code>defaultValue</code> property is set to the value of the {{domxref("Node.textContent","textContent")}} property.</p>

<p>Resetting the form puts the element into default mode, and sets the {{domxref("Node.textContent","textContent")}} property to the value of the <code>defaultValue</code> property.</p>

<h3 id="Value_mode">Value mode</h3>

<p>The element goes into value mode when the contents of the <code>value</code> property are set. The <code>value</code> property otherwise behaves like the {{domxref("Node.textContent","textContent")}} property. When the element is in value mode, the default value is accessible only through the <code>defaultValue</code> property.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#htmloutputelement", "HTMLOutputElement")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', "forms.html#the-output-element", "HTMLOutputElement")}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', "forms.html#the-output-element", "HTMLOutputElement")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLOutputElement")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The HTML element implementing this interface: {{HTMLElement("output")}}.</li>
</ul>
